#  MultiUtility
#  Copyright (C) 2005-2021
#  This file is part of MultiUtility.
#
#  MultiUtility is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published
#  by the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MultiUtility is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with MultiUtility.  If not, see <http://www.gnu.org/licenses/>.

import emoji
import re
from random import choice, randrange
from bs4 import BeautifulSoup
from .connection import MakeRequest

Client = MakeRequest()

class EmojiCreator:
    def __init__(self):
        "Emoji Client"
        self._base = "https://emojipedia.org"
        self.pages = []
    
    def get_random(self):
        if self.pages:
          url = choice(self.pages)
          return self._parse(self._parse_one(url))
        cnt = Client.get("https://emojipedia.org/people/").content
        bb = BeautifulSoup(cnt, "html.parser")
        spechi_jee = bb.find("ul", "emoji-list")
        gmama = spechi_jee.find_all("li")
        self.pages = [f"{self._base}{a.find('a')['href']}" for a in gmama]
        uedw = choice(self.pages)
        url = self._parse_one(uedw)
        return self._parse(url)

    def _parse_one(self, url):
        Dcnny = Client.get(url).content
        mwsd = BeautifulSoup(Dcnny, "html.parser")
        fww = mwsd.find_all("img", src=re.compile("emojipedia.us"))
        return choice([uri["src"] for uri in fww])
 
    def _parse(self, image):
        name = image.split("_")[-1].split("?")[0]
        name = Client.dl(image, ".downloads/" + str(randrange(9999999, 99999999)) + name)
        return name